unit StrProc;

interface

type
  TSetOfChar = set of char;

function PadLeft (S : String; Len : Byte) : String;
function PadRight (S : String; Len : Byte) : String;
function Power ( X, Y : integer ) : real;
function Trim (S: string): string;
function StripChars ( const Text : string; ValidChars : TSetOfChar ) : string;
function NbrOfItems (MultiItem: string): byte;
function GetItemStr (MultiItem: string; Nbr: byte): string;
function LinkWords (InStr: string): string;
function UnlinkWords (InStr: string): string;

implementation

function PadLeft (S : String; Len : Byte) : String;
var
  I : Byte;
begin
  if Length(S) < Len then
    for I := 1 to Len - Length(S) do
      S := S + ' ';
  PadLeft := Copy (S, 1, Len);
end;
function PadRight (S : String; Len : Byte) : String;
var
  I : Byte;
begin
  if Length(S) < Len then
    for I := 1 to Len - Length(S) do
      S := ' ' + S;
  PadRight := Copy (S, 1, Len);
end;

function Power ( X, Y : integer ) : real;
begin
  Result := exp ( ln ( X ) * Y );
end;

function StripChars ( const Text : string; ValidChars : TSetOfChar ) : string;
var
  S : string;
  i : integer;
Begin
  S := '';
  for i := 1 to length ( Text ) do
    if Text [ i ] in ValidChars then
      S := S + Text [ i ];
  Result := S;
End;
(*
function StripChars ( const Text : string; ValidChars : TSetOfChar ) : string;
var
  S : string;
  i : integer;
  Negative : boolean;
Begin
  Negative := false;
  if (Text [ 1 ] = '-') or (Text [length (Text)] = '-' ) then
    Negative := true;
  S := '';
  for i := 1 to length ( Text ) do
    if Text [ i ] in ValidChars then
      S := S + Text [ i ];
  if Negative then
    Result := '-' + S
  else
    Result := S;
End;
*)

(*function Trim;
    {-Return a string with leading and trailing white space removed}
  var
    I : Word;
    SLen : Byte absolute Result;
  begin
    Result := S;
    while (SLen > 0) and (Result[SLen] <= ' ') do
      Dec(SLen);

    I := 1;
    while (I <= SLen) and (Result[I] <= ' ') do
      Inc(I);
    Dec(I);
    if I > 0 then
      Delete(Result, 1, I);
  end;
*)
function Trim (S: string): string;
var
  ii: byte;
begin
   ii := 1;
   While (Length (S) >= ii) and
         (S [ii] = ' ') do
         inc (ii);
   S := copy (S, ii, 255);
   ii := Length (S);
   If ii = 0 then begin
      Trim := '';
      exit;
   end;
   While S [ii] = ' ' do
         dec (ii);
   Trim := copy (S, 1, ii);
end;


function   NbrOfItems (MultiItem: string): byte;
const
   Separator: char = ' ';
var
   Lng, I, J: byte;
begin
     NbrOfItems := 0;
     If Length (MultiItem) < 1 then
        exit;
     Lng := Length (MultiItem);
     j := 1;
     For i := 1 to Lng do
         If (MultiItem [i] = Separator) and (I <> Lng) then
            Inc (j);
     NbrOfItems := J;
end;

function   GetItemStr (MultiItem: string; Nbr: byte): string;
const
   Separator: char = ' ';
var
   j, i: byte;

begin
     GetItemStr := '';
     If Length (MultiItem) = 0 then
        exit;
     While (MultiItem [1] = Separator) and (Length (MultiItem) > 0) do
           MultiItem := Copy (Multiitem, 2, 80);
     i := 1; j := 1;
     While (i <> Nbr) and (Length (MultiItem) >= j) do begin
           If MultiItem [j] = Separator then
              inc (i);
           inc (j);
     end;
     If  (i <> Nbr) and (Length (MultiItem) < j) then
         Exit;
     i := 0;
     While (MultiItem [j + i] <> Separator) and (Length (MultiItem) >= j+i) do
           inc (i);

     GetItemStr := copy (MultiItem, j, i);
end;

function LinkWords (InStr: string): string;
var p: integer;
begin
   While pos (' ', InStr) <> 0 do begin
      p := pos (' ', InStr);
      InStr [p] := '_';
   end;
   result := InStr;
end;

function UnlinkWords (InStr: string): string;
var p: integer;
begin
   While pos ('_', InStr) <> 0 do begin
      p := pos ('_', InStr);
      InStr [p] := ' ';
   end;
   result := InStr;
end;

end.
