unit Umain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, inifiles, Grids,
  Mpanel, child1, proc, Menus;

type
  Tmainform = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel2: TPanel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    grid1: TStringGrid;
    ParentPanel1: TParentPanel;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Panel3: TPanel;
    File1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Comment1: TMenuItem;
    Gen1: TMenuItem;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    CloseBtn: TSpeedButton;
    PrintSetupBtn: TSpeedButton;
    PrintBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    FindBtn: TSpeedButton;
    FindAgainBtn: TSpeedButton;
    FindReplaceBtn: TSpeedButton;
    TagBtn: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    HelpBtn: TSpeedButton;
    Help1: TMenuItem;
    Content1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    Panel1: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure grid1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure GenitClick(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    currentname: string[128];
    thesection: string[128];
    procedure changesection(s:string);
    procedure process_comment(s:string);
    procedure update_memo_pos;
  public
    { Public declarations }
  end;

var
  mainform: Tmainform;

implementation
uses formfile;
{$R *.DFM}

Function pad(s:string;n:byte):string;
var i : byte;
begin
if length(s) < n then
  for i := length(s) to n do
    s := s + ' ';
pad := s;
end;


procedure Tmainform.process_comment(s:string);
var tmp:string;
    i: integer;
begin
with tinifile.create(changefileext(currentname,'.dat')) do
 begin
  tmp:= readstring('Comment',s,'');
  if ParentPanel1.form is tonecomment then
   begin
    onecomment.Memo1.lines.clear;
    onecomment.label2.caption := s;
    onecomment.Memo1.lines.add(tmp);
   end
  else
   begin
    procomment.name.caption := s;
    procomment.memo1.lines.clear;
    procomment.memo2.lines.clear;
    procomment.memo3.lines.clear;
    procomment.memo4.lines.clear;
    tmp := readstring('Comment',s +'1','');
    if tmp <> '' then
     procomment.memo1.lines.add(tmp);
    tmp := readstring('Comment',s +'2','');
    if tmp <> '' then
     procomment.memo2.lines.add(tmp);
    tmp := readstring('Comment',s +'3','');
    if tmp <> '' then
     procomment.memo3.lines.add(tmp);
    tmp := readstring('Comment',s +'4','');
    if tmp <> '' then
     procomment.memo4.lines.add(tmp);
   end;
  free;
 end;
end;

procedure Tmainform.changesection(s:string);
var t: tstringlist;
    i: integer;
begin

case s[1] of
    'V','T': ParentPanel1.form := onecomment;
    'C':     ParentPanel1.form := onecomment;
    'P': begin
         ParentPanel1.form := onecomment;
         if s[4] = 'c' then
          ParentPanel1.form := procomment;
         end;
    'F': ParentPanel1.form := procomment;
end;

 t:= Tstringlist.create;
 with tinifile.create(changefileext(currentname,'.dat')) do
   begin
    readsection(s,t);
    grid1.rowcount := 2;
    grid1.cells[0,1] := '';
    grid1.cells[1,1] := '';
    if t.count > 0 then
    begin
     grid1.rowcount := t.count +1;
     for i := 0 to t.count -1 do
      begin
        grid1.cells[0,i+1] := t[i];
        grid1.cells[1,i+1] := readstring(s,t[i],'');
      end;
    end;
    free;
   end;
 t.free;

end;

Procedure process_source(fname: string;skip:boolean);
var keys,inf: tstringlist;
    outf: Tinifile;
    S : string;
    i,f: integer;
begin
if not skip then
 formfile.process_source(fname);
 inf:= tstringlist.create;
 inf.loadfromfile(fname);
 keys:= tstringlist.create;
 keys.loadfromfile(extractfilepath(application.exename) + 'keys.dat');
 outf:= Tinifile.create(changefileext(fname,'.dat'));
 formfile .sortit(keys,inf,outf);
 inf.free;
 keys.free;
 outf.free;
end;

procedure Tmainform.FormCreate(Sender: TObject);
begin
 currentname := '';
 combobox1.items.loadfromfile(extractfilepath(application.exename) + 'keys.dat');
 combobox1.itemindex:= 0;
 grid1.cells[0,0] :='Name';
 grid1.cells[1,0] :='Line';
 panel4.caption := 'Col 0';
 panel5.caption := 'Line 0'
end;

procedure Tmainform.ComboBox1Change(Sender: TObject);
begin
 if pos(ComboBox1.text,thesection) = 0 then
  if currentname <> '' then
   begin
    thesection :=ComboBox1.text;
    changesection(ComboBox1.text);
   end;
end;

procedure Tmainform.grid1Click(Sender: TObject);
begin
 if memo1.lines.count = 0 then exit;
  process_comment(grid1.cells[0,grid1.row]);
  SendMessage(Memo1.Handle, WM_VSCROLL, SB_THUMBPOSITION, strtoint(grid1.cells[1,grid1.row])-1);             
end;

procedure Tmainform.Exit1Click(Sender: TObject);
begin
close;
end;

procedure Tmainform.Open1Click(Sender: TObject);
begin
 if OpenDialog1.execute then
  if currentname = OpenDialog1.filename then
   exit
  else
   currentname:= OpenDialog1.filename;
 if (currentname <> '')  then
  begin
   caption:= application.title + '-' + currentname;
   process_source(currentname,false);
   combobox1.itemindex:= 0;
   changesection(combobox1.text);
   memo1.lines.loadfromfile(currentname);
  end;
end;

procedure Tmainform.GenitClick(Sender: TObject);
var s,s2: string;
    i,n : integer;
begin
  s:= '';
  if currentname = '' then exit;
  if ParentPanel1.form is tonecomment then
  begin
    if (onecomment.label2.caption = '') then exit;
    if (onecomment.Memo1.lines.count = 0) then exit;
    for i:= 0 to onecomment.Memo1.lines.count -1 do
        s:= s + onecomment.Memo1.lines[i] + ' ';
     with tinifile.create(changefileext(currentname,'.dat')) do
     begin
      writestring('Comment', onecomment.label2.caption,s);
      free;
     end;
    s2:= memo1.lines[strtoint(grid1.cells[1,grid1.row])];
    i:= pos('{',s2);
    if i > 0 then
     s2:= copy(s2,1,i-1);
    s2 := s2 + ' ' + s;
    memo1.lines[strtoint(grid1.cells[1,grid1.row])] := s2;
  end
  else
   begin
    if procomment.name.caption = '' then exit;
    with tinifile.create(changefileext(currentname,'.dat')) do
     begin
     n:= strtoint(grid1.cells[1,grid1.row]);
     if (procomment.Memo1.lines.count > 0) then
      for i:= 0 to procomment.Memo1.lines.count -1 do
       begin
         if Memo1.lines[n][1] <> '{' then
          begin
           Memo1.lines.insert(n,pad('{* ' + procomment.label1.caption +': ' + procomment.Memo1.lines[i] + ' *}',70));
           inc(n);
          end
         else
           Memo1.lines[n] := '{* ' + pad(procomment.label1.caption +': ' + procomment.Memo1.lines[i] + ' *}',70);
         s:= s + procomment.Memo1.lines[i];
       end;
    writestring('Comment',procomment.name.caption + '1', s);
    s:= '';
      if (procomment.Memo2.lines.count > 0) then
      for i:= 0 to procomment.Memo2.lines.count -1 do
       begin
         if Memo1.lines[n][1] <> '{' then
          begin
           Memo1.lines.insert(n,'{* ' + pad(procomment.label2.caption +': ' + procomment.Memo2.lines[i] + ' *}',70));
           inc(n);
          end
         else
           Memo1.lines[n] := '{* ' + pad(procomment.label2.caption +': ' + procomment.Memo2.lines[i] + ' *}',70);
         s:= s + procomment.Memo2.lines[i];
       end;
    writestring('Comment',procomment.name.caption + '2', s);
    s:= '';
      if (procomment.Memo3.lines.count > 0) then
      for i:= 0 to procomment.Memo3.lines.count -1 do
       begin
         if Memo1.lines[n][1] <> '{' then
          begin
           Memo1.lines.insert(n,'{* ' + pad(procomment.label3.caption +': ' + procomment.Memo4.lines[i] + ' *}',70));
           inc(n);
          end
         else
           Memo1.lines[n] := '{* ' + pad(procomment.label3.caption +': ' + procomment.Memo4.lines[i] + ' *}',70);
         s:= s + procomment.Memo3.lines[i];
       end;
    writestring('Comment',procomment.name.caption + '3', s);
    s:= '';
     if (procomment.Memo4.lines.count > 0) then
      for i:= 0 to procomment.Memo4.lines.count -1 do
       begin
         if Memo1.lines[n][1] <> '{' then
          begin
           Memo1.lines.insert(n,'{* ' + pad(procomment.label4.caption +': ' + procomment.Memo4.lines[i] + ' *}',70));
           inc(n);
          end
         else
           Memo1.lines[n] := '{* ' + pad(procomment.label4.caption +': ' + procomment.Memo4.lines[i] + ' *}',70);
         s:= s + procomment.Memo4.lines[i];
       end;
    writestring('Comment',procomment.name.caption + '4', s);
    free;
    end;
    s:= '';
   end;

  memo1.lines.savetofile(currentname);
  process_source(currentname,true);
  changesection(combobox1.text);
end;

procedure Tmainform.update_memo_pos;
var lpos, cpos: longint;
begin
 Lpos := SendMessage(memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0);
 Cpos := SendMessage(memo1.Handle,EM_LINEINDEX,Lpos,0);
 CPos := Memo1.SelStart-CPos;
 panel4.caption := 'Col ' + inttostr(cpos);
 panel5.caption := 'Line ' + inttostr(lpos);
 end;

procedure Tmainform.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 update_memo_pos;
end;

procedure Tmainform.Memo1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 update_memo_pos;
end;

end.
